]> git.notmuchmail.org Git - notmuch/blob - test/notmuch-test
lib: support user prefix names in term generation
[notmuch] / test / notmuch-test
1 #!/usr/bin/env bash
2
3 # Run tests
4 #
5 # Copyright (c) 2005 Junio C Hamano
6 # Copyright (c) 2010 Notmuch Developers
7 #
8 # Adapted from a Makefile to a shell script by Carl Worth (2010)
9
10 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
11     echo "Error: The notmuch test suite requires a bash version >= 4.0"
12     echo "due to use of associative arrays within the test suite."
13     echo "Please try again with a newer bash (or help us fix the"
14     echo "test suite to be more portable). Thanks."
15     exit 1
16 fi
17
18 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
19 . $(dirname "$0")/export-dirs.sh || exit 1
20
21 TESTS=
22 for test in $NOTMUCH_TESTS; do
23     TESTS="$TESTS $NOTMUCH_SRCDIR/test/$test"
24 done
25
26 if [[ -z "$TESTS" ]]; then
27     TESTS="$NOTMUCH_SRCDIR/test/T[0-9][0-9][0-9]-*.sh"
28 fi
29
30 # Clean up any results from a previous run
31 rm -rf $NOTMUCH_BUILDDIR/test/test-results
32
33 # Test for timeout utility
34 if command -v timeout >/dev/null; then
35     TEST_TIMEOUT=${NOTMUCH_TEST_TIMEOUT:-2m}
36     TEST_TIMEOUT_CMD="timeout $TEST_TIMEOUT"
37     echo "INFO: using $TEST_TIMEOUT timeout for tests"
38 else
39     TEST_TIMEOUT_CMD=""
40 fi
41
42 trap 'e=$?; kill $!; exit $e' HUP INT TERM
43 # Run the tests
44 if test -z "$NOTMUCH_TEST_SERIALIZE" && command -v parallel >/dev/null ; then
45     test -t 1 && export COLORS_WITHOUT_TTY=t || :
46     if parallel -h | grep -q GNU ; then
47         echo "INFO: running tests with GNU parallel"
48         printf '%s\n' $TESTS | $TEST_TIMEOUT_CMD parallel
49     else
50         echo "INFO: running tests with moreutils parallel"
51         $TEST_TIMEOUT_CMD parallel -- $TESTS
52     fi
53     RES=$?
54     if [[ $RES != 0 ]]; then
55         echo "parallel test suite returned error code $RES"
56         exit $RES
57     fi
58 else
59     for test in $TESTS; do
60         $TEST_TIMEOUT_CMD $test "$@" &
61         wait $!
62         # If the test failed without producing results, then it aborted,
63         # so we should abort, too.
64         RES=$?
65         testname=$(basename $test .sh)
66         if [[ $RES != 0 && ! -e "$NOTMUCH_BUILDDIR/test/test-results/$testname" ]]; then
67             exit $RES
68         fi
69     done
70 fi
71 trap - HUP INT TERM
72
73 # Report results
74 echo
75 $NOTMUCH_SRCDIR/test/aggregate-results.sh $NOTMUCH_BUILDDIR/test/test-results/*
76 ev=$?
77
78 # Clean up
79 rm -rf $NOTMUCH_BUILDDIR/test/test-results
80
81 exit $ev